// Code generated by OpenAPI Generator (https://openapi-generator.tech), manual changes will be lost - read more on https://github.com/algolia/api-clients-automation. DO NOT EDIT.
// ignore_for_file: unused_element
import 'package:algolia_client_recommend/src/model/search_params.dart';
import 'package:algolia_client_recommend/src/model/trending_items_model.dart';
import 'package:algolia_client_recommend/src/model/search_params_object.dart';

import 'package:json_annotation/json_annotation.dart';

part 'trending_items_query.g.dart';

@JsonSerializable()
final class TrendingItemsQuery {
  /// Returns a new [TrendingItemsQuery] instance.
  const TrendingItemsQuery({
    required this.indexName,
    required this.threshold,
    this.maxRecommendations,
    this.queryParameters,
    required this.facetName,
    required this.facetValue,
    required this.model,
    this.fallbackParameters,
  });

  /// Index name (case-sensitive).
  @JsonKey(name: r'indexName')
  final String indexName;

  /// Minimum score a recommendation must have to be included in the response.
  // minimum: 0
  // maximum: 100
  @JsonKey(name: r'threshold')
  final double threshold;

  /// Maximum number of recommendations to retrieve. By default, all recommendations are returned and no fallback request is made. Depending on the available recommendations and the other request parameters, the actual number of recommendations may be lower than this value.
  // minimum: 1
  // maximum: 1000
  @JsonKey(name: r'maxRecommendations')
  final int? maxRecommendations;

  @JsonKey(name: r'queryParameters')
  final SearchParams? queryParameters;

  /// Facet attribute. To be used in combination with `facetValue`. If specified, only recommendations matching the facet filter will be returned.
  @JsonKey(name: r'facetName')
  final String facetName;

  /// Facet value. To be used in combination with `facetName`. If specified, only recommendations matching the facet filter will be returned.
  @JsonKey(name: r'facetValue')
  final String facetValue;

  @JsonKey(name: r'model')
  final TrendingItemsModel model;

  @JsonKey(name: r'fallbackParameters')
  final SearchParamsObject? fallbackParameters;

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is TrendingItemsQuery &&
          other.indexName == indexName &&
          other.threshold == threshold &&
          other.maxRecommendations == maxRecommendations &&
          other.queryParameters == queryParameters &&
          other.facetName == facetName &&
          other.facetValue == facetValue &&
          other.model == model &&
          other.fallbackParameters == fallbackParameters;

  @override
  int get hashCode =>
      indexName.hashCode +
      threshold.hashCode +
      maxRecommendations.hashCode +
      queryParameters.hashCode +
      facetName.hashCode +
      facetValue.hashCode +
      model.hashCode +
      fallbackParameters.hashCode;

  factory TrendingItemsQuery.fromJson(Map<String, dynamic> json) =>
      _$TrendingItemsQueryFromJson(json);

  Map<String, dynamic> toJson() => _$TrendingItemsQueryToJson(this);

  @override
  String toString() {
    return toJson().toString();
  }
}
